#include <stdio.h>
#include <stdlib.h>
#include "arbre.h"

Arbre	arbreNouv(void)
{
	return NULL;
}

void	viderArbre(Arbre a)
{
	if(vide(a))
	{
		return;
	}
	viderArbre(a->g);
	viderArbre(a->d);
	free(a);
}

bool	vide(Arbre a)
{
	return a == NULL;
}

void	afficherRacine(int v, int k)
{
	int	i;
	
	i = 0;
	while(i < k)
	{
		printf("---");
		i++;
	}
	printf("%d\n", v);
}

Arbre	e(Arbre a, int x, Arbre b)
{
	Maillon *m;

	m = (Maillon *)malloc(sizeof(Maillon));
	if(!m)
	{
		printf("erreur allocation memoire enracinement");
		exit(1);
	}
	m->v = x;
	m->g = a;
	m->d = b;
	return m;
}

void	afficherArbre(Arbre a)
{
	afficherArb(a, 0);
}

void	afficherArb(Arbre a, int k)
{
	if(vide(a))
	{
		return;
	}
	afficherArb(ad(a), ++k);
	afficherRacine(r(a), k);
	afficherArb(ag(a), ++k);
}

Arbre	ag(Arbre a)
{
	if(vide(a))
	{
		printf("operation interdite ag");
		exit(1);
	}
	return a->g;
}

Arbre	ad(Arbre a)
{
	if(vide(a))
	{
		printf("operation interdite ad");
		exit(1);
	}
	return a->d;
}

int	r(Arbre a)
{
	if(vide(a))
	{
		printf("operation interdite racine");
		exit(1);
	}
	return a->v;
}

int	h(Arbre a)
{
	if(vide(a))
	{
		return -1;
	}
	return 1 + max(h(ag(a)), h(ad(a)));
}

int	max(int a, int b)
{
	if(a > b)
	{
		return a;
	}
	return b;
}

bool	f(Arbre a)
{
	if(vide(a))
	{
		return false;
	}
	return vide(ag(a)) && vide(ad(a));
}

int	nf(Arbre a)
{
	if(vide(a))
	{
		return 0;
	}
	if(f(a))
	{
		return 1;
	}
	return nf(ag(a)) + nf(ad(a));
}

Arbre	eg(Arbre a)
{
	if(vide(a))
	{
		return a;
	}
	if(vide(ag(0)))
	{
		return e(arbreNouv(), r(a), arbreNouv());
	}
	return eg(ag(a));
}


Arbre	ed(Arbre a)
{
	if(vide(a))
	{
		return a;
	}
	if(vide(ad(0)))
	{
		return e(arbreNouv(), r(a), arbreNouv());
	}
	return ed(ad(a));
}
